<template>
  <div class="ele-body">
    <a-card style="width: 100%" :bordered="false">
      <template #title>
        <a-space>
          <a-select
            ref="select"
            v-model:value="regionLevel"
            style="width: 120px"
          >
            <a-select-option value="city">市</a-select-option>
            <a-select-option value="county">县</a-select-option>
          </a-select>
          <a-upload
            :before-upload="importFile"
            :showUploadList="false"
            accept=".xls,.xlsx,.csv"
          >
            <a-button type="primary">数据导入</a-button>
          </a-upload>
          <a-button @click="download">模板下载</a-button>
        </a-space>
      </template>
      <a-tabs v-model:activeKey="activeKey">
        <a-tab-pane tab="噪声信息" key="noise">
          <noise-bill ref="noise"></noise-bill>
        </a-tab-pane>
      </a-tabs>
    </a-card>
  </div>
</template>

<script>
import XLSX from "xlsx";
import utils from "./utils";
import {Modal} from "ant-design-vue";
import NoiseBill from "./noise-bill.vue";
import {saveZoneNoiseBill} from "@/api/ecology/noise/zone-sound";
import {downloadTemplate} from "@/utils/excel-util";

export default {
  name: "ZoneCollectIndex",
  components: {
    NoiseBill,
  },
  data() {
    return {
      activeKey: "noise",
      regionLevel: "city"
    };
  },
  methods: {
    download() {
      let filename = "区域噪声-"
      if (this.regionLevel == "city") {
        filename += "市"
      } else if (this.regionLevel == "county") {
        filename += "县"
      } else {
        filename += "站点"
      }
      downloadTemplate(filename)
    },
    importFile(file) {
      if (this.regionLevel == "city") {
        this.importFileCity(file);
      } else {
        this.importFileCounty(file);
      }
    },
    /* 导入本地excel文件 */
    importFileCity(file) {
      const hide = this.$message.loading("导入中..", 0);

      let reader = new FileReader();
      reader.onload = (e) => {
        try {
          let data = new Uint8Array(e.target.result);
          let workbook = XLSX.read(data, {
            type: "array",
          });
          //0.昼间数据 1.夜间数据 2.其他信息
          let sheetNames = workbook.SheetNames;
          // 解析成二维数组
          let aoa = XLSX.utils.sheet_to_json(workbook.Sheets[sheetNames[0]], {
            header: 1,
          });
          let aoa2 = XLSX.utils.sheet_to_json(workbook.Sheets[sheetNames[1]], {
            header: 1,
          });

          const reportDate = aoa[1][0].replace(/[^\d]+/g, "-");
          const reportDate2 = aoa2[1][0].replace(/[^\d]+/g, "-");

          const zoneNoiseList = aoa.filter(
            (item) => {
              return item.length >= 26 && typeof item[0] == "number"
            }
          );
          const zoneNoiseList2 = aoa2.filter(
            (item) => item.length >= 26 && typeof item[0] == "number"
          );


          // 解析成对象数组
          const billName = file.name;
          const billData = utils.toObjData(zoneNoiseList);
          const billName2 = file.name;
          const billData2 = utils.toObjData(zoneNoiseList2);
          if (
            (!billData || billData.length == 0) &&
            (!billData2 || billData2.length == 0)
          ) {
            hide()
            Modal.error({
              title: "导入失败",
              content: "找不到数据",
            });
            return;
          }

          const tasks = [];
          if (billData.length > 0) {
            tasks.push(
              saveZoneNoiseBill({
                reportTime: new Date(reportDate).getTime(),
                billName: billName,
                regionLevel: "市级",
                zoneNoiseList: billData,
              })
            );
          }

          if (billData2.length > 0) {
            tasks.push(
              saveZoneNoiseBill({
                reportTime: new Date(reportDate2).getTime(),
                billName: billName2,
                regionLevel: "市级",
                zoneNoiseList: billData2,
              })
            );
          }

          // 上传到服务器

          Promise.all(tasks)
            .then(() => {
              Modal.success({
                title: "导入成功",
                content: `成功导入${billData.length + billData2.length}条数据`,
              });
              this.$refs.noise && this.$refs.noise.reload();
            })
            .catch(() => {
              Modal.error({
                title: "导入失败",
                content: "数据上传出错",
              });
            })
            .finally(() => {
              hide();
            });
        } catch (error) {
          hide();
          Modal.error({
            title: "导入失败",
            content: error.message,
          });
        }
        // console.log(billData);
      };
      reader.readAsArrayBuffer(file);

      return false;
    },
    importFileCounty(file) {
      const hide = this.$message.loading("导入中..", 0);

      let reader = new FileReader();

      reader.onload = (e) => {
        try {
          let data = new Uint8Array(e.target.result);
          let workbook = XLSX.read(data, {
            type: "array",
          });
          //0.昼间数据 1.夜间数据 2.其他信息
          let sheetNames = workbook.SheetNames;
          // 解析成二维数组
          let aoa = XLSX.utils.sheet_to_json(workbook.Sheets[sheetNames[0]], {
            header: 1,
          });

          const reportDate = aoa[1][0].replace(/[^\d]+/g, "-");
          const zoneNoiseList = aoa.filter(
            (item) => {

              return item.length >= 28 && item[0] && !item[0].toString().includes("行政区划代码")
            }
          );

          // 解析成对象数组
          const billName = file.name;
          const billData = utils.toAreaObjData(zoneNoiseList);

          if (!billData || billData.length == 0) {
            hide();
            Modal.error({
              title: "导入失败",
              content: "找不到可用数据",
            });

            return;
          }

          if (billData.length > 0) {
            // 上传到服务器
            saveZoneNoiseBill({
              reportTime: new Date(reportDate).getTime(),
              billName: billName,
              regionLevel: "县级",
              zoneNoiseList: billData,
            })
              .then((res) => {
                if (res.data.code == 0) {
                  Modal.success({
                    title: "导入成功",
                    content: `成功导入${
                      billData.length
                    }条数据`,
                  });
                  this.$refs.noise && this.$refs.noise.reload();
                } else {
                  Modal.error({
                    title: "导入失败",
                    content: "数据上传出错",
                  });
                }
              })
              .catch(() => {
                Modal.error({
                  title: "导入失败",
                  content: "数据上传出错",
                });
              })
              .finally(() => {
                hide();
              });
          }
        } catch (error) {
          hide();
          Modal.error({
            title: "导入失败",
            content: error.message,
          });
        }
        // console.log(billData);
      };
      reader.readAsArrayBuffer(file);
      return false;
    },
  },
};
</script>

<style scoped lang="less">
</style>
